/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using Battlehub.RTCommon;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using UnityEngine.UI;using System.Security.Cryptography;using System.Text;using System;using MVR.FileManagementSecure;namespace PluginIdea.MetaVRPlayer{public class UserPreferencesRecord{public bool softPhysics;public bool mirrorToDisplay;public bool realtimeReflectionProbes;public int pixelLightCount;public bool physicsHighQuality;public int msaaLevel;public UserPreferences.GlowEffectsLevel glowEffects;public int smoothPasses;}public struct ContentFormat{public const int Mono = 0;public const int TopBottom = 1;public const int LeftRight = 2;}public class MetaVRPlayer : MVRScript{public const string VideoPlayerModule = "VideoPlayerModule";public const string ImagePlayerModule = "ImagePlayerModule";public const string GrabModule = "GrabModule";public const string SettingModule = "SettingModule";public const string PlayControllerModule = "PlayControllerModule";private Dictionary<string, VRPlayerModuleBase> uid2Modules = new Dictionary<string, VRPlayerModuleBase>();private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private Dictionary<string, Material> dic_BundleMaterials = new Dictionary<string, Material>();private Dictionary<string, GameObject> dic_BundleObjects = new Dictionary<string, GameObject>();private Request request;private bool isExternalResourcesLoaded;private int cameraLastCullMask;private Renderer sphereBallRenderer;private Renderer vrsphereRenderer;private UserPreferencesRecord lastUserPreferencesRecord;public bool isFree = false;public ImagePlayerModule imgModule;public VideoPlayerModule videoModule;public SettingModule settingModule;public PlayControllerModule playCtrModule;public bool IsInitied{get{return isExternalResourcesLoaded;}}private bool isVR180;public bool IsVR180{get{return isVR180;}set{string shaderName = value ? "PluginIdea/InsideSphere180" : "PluginIdea/InsideSphere360";vrsphereRenderer.material.shader = dic_BundleShaders[shaderName];}}private bool isEnter;public bool IsEnter{get{return isEnter;}set{isEnter = value;if (vrsphereRenderer) vrsphereRenderer.gameObject.SetActive(value);QualitySetting(value);if (isEnter && GlobalSetting.isHideOtherWhenEnterVR){int tlayer = Utils.IsInVR() ? LayerMask.NameToLayer("UI") : LayerMask.NameToLayer("Default");sphereBallRenderer.gameObject.layer = tlayer;Utils.CenterCamera.cullingMask = 1 << LayerMask.NameToLayer("UI");}else{sphereBallRenderer.gameObject.layer = LayerMask.NameToLayer("Default");Utils.CenterCamera.cullingMask = cameraLastCullMask;}if (value){if (!GlobalSetting.isOnImageType) videoModule.OnEnter();else imgModule.OnEnter();playCtrModule.OnEnter();}else{if (!GlobalSetting.isOnImageType) videoModule.OnOut();else imgModule.OnOut();playCtrModule.OnOut();}}}private int currentRenderMode;public int CurrentRenderMode{get{return currentRenderMode;}set{currentRenderMode = value;vrsphereRenderer.material.SetFloat("Stereo", currentRenderMode);}}private bool flip;public bool Flip{get{return flip;}set{flip = value;if (flip){vrsphereRenderer.material.EnableKeyword("FLIP");}else{vrsphereRenderer.material.DisableKeyword("FLIP");}}}private Canvas controllerCanvas;public Canvas ControllerCanvas{get{return controllerCanvas;}}public Renderer SphereBallRenderer{get{return sphereBallRenderer;}}public Texture2D CurrentFrameTexture{get{return GlobalSetting.isOnImageType ? imgModule.GetCurrentFrame() : videoModule.GetCurrentFrame();}}public Texture MainTexture{set{if (vrsphereRenderer != null){vrsphereRenderer.material.mainTexture = value;}}}public Renderer VRSphereRenderer{get{return vrsphereRenderer;}}public override void Init(){Location.InitTData();DataInit();UIInit();EventInit();RegistBundleUnload();}private void DataInit(){string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/vrplayer1.assetbundle";request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request.assetBundle != null){request.assetBundle.Unload(false);}}private void OnAssetBundleLoaded(Request abffr){Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}Material[] materials = request.assetBundle.LoadAllAssets<Material>();for (int i = 0;i < materials.Length;i++){if (!dic_BundleMaterials.ContainsKey(materials[i].name)){string key = materials[i].name;dic_BundleMaterials.Add(key, materials[i]);}}GameObject[] objects = request.assetBundle.LoadAllAssets<GameObject>();for (int i = 0;i < objects.Length;i++){if (!dic_BundleObjects.ContainsKey(objects[i].name)){string key = objects[i].name;dic_BundleObjects.Add(key, objects[i]);}}Transform rescaleObject = containingAtom.reParentObject.Find("object/rescaleObject");GameObject sphereballObject = GameObject.CreatePrimitive(PrimitiveType.Sphere);sphereballObject.transform.localScale = Vector3.one * GlobalSetting.sphereBallScaleRadio;sphereballObject.name = "PreviewBall";sphereballObject.transform.SetParent(rescaleObject);sphereballObject.transform.SetPositionAndRotation(rescaleObject.position, rescaleObject.rotation);sphereBallRenderer = Utils.GetSafeComponent<Renderer>(sphereballObject);sphereBallRenderer.material = dic_BundleMaterials["SphereBall"];GameObject sphereObject = GameObject.CreatePrimitive(PrimitiveType.Sphere);sphereObject.name = "VRContentBall";sphereObject.layer = LayerMask.NameToLayer("UI");vrsphereRenderer = Utils.GetSafeComponent<Renderer>(sphereObject);if (Utils.IsInVR()){sphereObject.transform.SetParent(Utils.CenterCameraTrans.parent);}sphereObject.transform.localPosition = Vector3.zero;sphereObject.transform.localRotation = Quaternion.identity;sphereObject.transform.localScale = new Vector3(200, 200, 200);sphereObject.SetActive(false);controllerCanvas = Utils.AppendCanvasObjectUnderHeadCenter("ContexViewSpaceCanvasX", true);GameObject cRoot = Instantiate<GameObject>(dic_BundleObjects["ControllerPanel"]);cRoot.transform.SetParent(controllerCanvas.transform);cRoot.transform.localScale = Vector3.one;cRoot.transform.localPosition = Vector3.zero;cRoot.transform.localRotation = Quaternion.identity;controllerCanvas.gameObject.SetActive(false);cameraLastCullMask = Utils.CenterCamera.cullingMask;isExternalResourcesLoaded = true;foreach (var module in uid2Modules.Values.ToList()){module.DelayInit();}}public void SyncSourceFormat(string filename){filename = filename.Substring(0, filename.LastIndexOf('.'));Debug.Log(filename);if (filename.Contains("&")){var tarr = filename.Split('&');if (tarr.Length == 3){string align = tarr[1];string dgree = tarr[2];bool is180 = dgree == "180";settingModule.isVR180.val = is180;switch (align){case "M":                           settingModule.sourceFormat.val = "Mono";break;case "UD":                            settingModule.sourceFormat.val = "UpBottom";break;case "LR":                            settingModule.sourceFormat.val = "LeftRight";break;default:                            break;}}}}private void QualitySetting(bool isEnterVR){if (isEnterVR){lastUserPreferencesRecord = new UserPreferencesRecord(){softPhysics = UserPreferences.singleton.softPhysics,                    mirrorToDisplay = UserPreferences.singleton.mirrorToDisplay,                    realtimeReflectionProbes = UserPreferences.singleton.realtimeReflectionProbes,                    pixelLightCount = UserPreferences.singleton.pixelLightCount,                    physicsHighQuality = UserPreferences.singleton.physicsHighQuality,                    msaaLevel = UserPreferences.singleton.msaaLevel,                    glowEffects = UserPreferences.singleton.glowEffects,                    smoothPasses = UserPreferences.singleton.smoothPasses,};if (GlobalSetting.isColseOtherEffectWhenEnterVR){UserPreferences.singleton.softPhysics = false;UserPreferences.singleton.mirrorToDisplay = false;UserPreferences.singleton.realtimeReflectionProbes = false;UserPreferences.singleton.pixelLightCount = 0;UserPreferences.singleton.physicsHighQuality = false;UserPreferences.singleton.msaaLevel = 0;UserPreferences.singleton.glowEffects = UserPreferences.GlowEffectsLevel.Off;UserPreferences.singleton.smoothPasses = 0;}}else{if (lastUserPreferencesRecord != null){UserPreferences.singleton.softPhysics = lastUserPreferencesRecord.softPhysics;UserPreferences.singleton.mirrorToDisplay = lastUserPreferencesRecord.mirrorToDisplay;UserPreferences.singleton.realtimeReflectionProbes = lastUserPreferencesRecord.realtimeReflectionProbes;UserPreferences.singleton.pixelLightCount = lastUserPreferencesRecord.pixelLightCount;UserPreferences.singleton.physicsHighQuality = lastUserPreferencesRecord.physicsHighQuality;UserPreferences.singleton.msaaLevel = lastUserPreferencesRecord.msaaLevel;UserPreferences.singleton.glowEffects = lastUserPreferencesRecord.glowEffects;UserPreferences.singleton.smoothPasses = lastUserPreferencesRecord.smoothPasses;}}}private void UIInit(){Utils.InitUI(CreateUIElement);if (isFree){var btn = Utils.CreateButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false, true);btn.buttonImage.color = Color.yellow;Utils.CreateSpacer(this, 30, false);}Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PluginInfo), 300, true);}private void Update(){foreach (var module in uid2Modules.Values.ToList()){module.OnUpdate();}}private void EventInit(){imgModule = new ImagePlayerModule(this);videoModule = new VideoPlayerModule(this);settingModule = new SettingModule(this);playCtrModule = new PlayControllerModule(this);RegisterModule(SettingModule, settingModule);RegisterModule(ImagePlayerModule, imgModule);RegisterModule(VideoPlayerModule, videoModule);RegisterModule(PlayControllerModule, playCtrModule);if (Utils.IsInVR())                RegisterModule(GrabModule, new GrabModule(this));}private bool bs(string pd){string s = Location.r("_moc") + GMAAP();string tmp = MDPWd(s);return pd == tmp;}private string MDPWd(string rpwd){string Ret;MD5 md5 = new MD5CryptoServiceProvider();byte[] palindata = Encoding.Default.GetBytes(rpwd);byte[] encryptdata = md5.ComputeHash(palindata);Ret = Convert.ToBase64String(encryptdata);return Ret;}private string GMAAP(){var pp = GMAA();var ppa = pp.Split('_');string s = ppa[0] + "_" + ppa[1];return s;}private string GMAA(){var gid = SystemInfo.graphicsDeviceID;var vf = SystemInfo.graphicsDeviceVendorID;var rdd = UnityEngine.Random.Range(10000, 999990).GetHashCode();return string.Format("{0}_{1}_{2}", gid, vf, rdd).ToString();}private void RegisterModule(string key, VRPlayerModuleBase module){if (!uid2Modules.ContainsKey(key)){uid2Modules.Add(key, module);module.Init();}}private void UnRegisterModule(string key){if (uid2Modules.ContainsKey(key)){uid2Modules[key].UnInit();uid2Modules.Remove(key);}}private void OnDestroy(){if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}if (uid2Modules.Count > 0){foreach (var key in uid2Modules.Keys.ToList()){UnRegisterModule(key);}uid2Modules.Clear();}QualitySetting(false);if(vrsphereRenderer) Destroy(vrsphereRenderer.gameObject);if(sphereBallRenderer) Destroy(sphereBallRenderer.gameObject);if (controllerCanvas) Destroy(controllerCanvas.gameObject);Utils.DestroyUI();}}}