/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using System;namespace PluginIdea.MetaVRPlayer{public struct GrabState{public const int OnStart = 0;public const int DraggingFromStart = 1;public const int DraggingFromHead = 2;public const int OnHead = 3;}public class GrabModule : VRPlayerModuleBase{private Vector3 beginPosition;private Quaternion beginRotation;private int grabState = GrabState.OnStart;private float triggerDistance = 0.3f;private bool IsGrabHandLeft{get{return SuperController.singleton.GetLeftGrabVal() > .02f;}}private bool IsGrabHandRight{get{return SuperController.singleton.GetRightGrabVal() > .02f;}}private Vector3 MinOffset{get{var mainController = ower.GetMainController();Transform lhand = SuperController.singleton.leftHand;Transform rhand = SuperController.singleton.rightHand;float disl = Vector3.Distance(lhand.position, mainController.transform.position);float disr = Vector3.Distance(rhand.position, mainController.transform.position);if (disl < disr){return mainController.transform.position - lhand.position;}else{return mainController.transform.position - rhand.position;}}}private float DisFromHand2Head{get{Transform lhand = SuperController.singleton.leftHand;Transform rhand = SuperController.singleton.rightHand;float disl = Vector3.Distance(lhand.position, Utils.CenterCameraTrans.position);float disr = Vector3.Distance(rhand.position, Utils.CenterCameraTrans.position);return Mathf.Min(disl, disr);}}public GrabModule(MetaVRPlayer ower){this.ower = ower;}public override void Init(){}private bool isOnGrab;public override void OnUpdate(){var mainController = ower.GetMainController();if (grabState == GrabState.OnHead){mainController.transform.position = Utils.CenterCameraTrans.position;}Transform lhand = SuperController.singleton.leftHand;Transform rhand = SuperController.singleton.rightHand;float disl = Vector3.Distance(lhand.position,mainController.transform.position);float disr = Vector3.Distance(rhand.position, mainController.transform.position);float minHandDis = Mathf.Min(disl, disr);if (minHandDis >= GlobalSetting.triggerRadius) return;float grabVal = Mathf.Max(SuperController.singleton.GetLeftGrabVal(), SuperController.singleton.GetRightGrabVal());if (grabVal > 0.02f){if (!isOnGrab){OnBeginGrab();isOnGrab = true;}}else{if (isOnGrab){OnEndGrab();isOnGrab = false;}}if (grabState == GrabState.DraggingFromStart || grabState == GrabState.DraggingFromHead){float alpha = 1;if (DisFromHand2Head < triggerDistance){alpha = (DisFromHand2Head - triggerDistance * 0.8f) / triggerDistance;}if (grabState == GrabState.DraggingFromHead){Vector3 pos = beginPosition;if (IsGrabHandLeft) pos = SuperController.singleton.leapHandLeft.position;else if (IsGrabHandRight) pos = SuperController.singleton.rightHand.position;ower.GetMainController().transform.position = pos;}ower.SphereBallRenderer.material.SetFloat("_Alpha", alpha);}}private void OnBeginGrab(){if (grabState == GrabState.OnHead && DisFromHand2Head < triggerDistance){grabState = GrabState.DraggingFromHead;ower.SphereBallRenderer.gameObject.SetActive(true);GlobalSetting.isDraggingFromHead = true;}if (grabState == GrabState.OnStart){grabState = GrabState.DraggingFromStart;beginPosition = ower.GetMainController().transform.position;beginRotation = ower.GetMainController().transform.rotation;}}private void OnEndGrab(){GlobalSetting.isDraggingFromHead = false;if (grabState == GrabState.DraggingFromHead){if (DisFromHand2Head > triggerDistance){ower.IsEnter = false;grabState = GrabState.OnStart;ower.SphereBallRenderer.material.SetFloat("_Alpha", 1);ower.GetMainController().transform.position = beginPosition;}else{grabState = GrabState.OnHead;ower.SphereBallRenderer.material.SetFloat("_Alpha", 0);ower.SphereBallRenderer.gameObject.SetActive(false);ower.IsEnter = true;}}if (grabState == GrabState.DraggingFromStart){if (DisFromHand2Head < triggerDistance){ower.IsEnter = true;grabState = GrabState.OnHead;ower.SphereBallRenderer.material.SetFloat("_Alpha", 0);ower.SphereBallRenderer.gameObject.SetActive(false);}else{grabState = GrabState.OnStart;ower.SphereBallRenderer.material.SetFloat("_Alpha", 1);ower.GetMainController().transform.position = beginPosition;ower.IsEnter = false;}}ower.GetMainController().transform.rotation = beginRotation;}public override void UnInit(){}}}