/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using System;namespace PluginIdea.MetaVRPlayer{public class ImagePlayerModule : VRPlayerModuleBase{private const string DefaultImagePath = "Custom/Assets/Images";private TextureSettings slideTextureSetting = new TextureSettings(){compress = true, linearColor = false};private List<string> playModes = new List<string>{"Random", "Sequence", "Sequence Inverse"};private List<int> randomPool = new List<int>();private List<string> imageList = new List<string>();private Texture2D currentTex;private JSONStorableUrl folderPath;public JSONStorableAction nextImgAction;public JSONStorableAction prevImgAction;private string currentFolderUrl;public ImagePlayerModule(MetaVRPlayer ower){this.ower = ower;}public override void Init(){Utils.CreateInfoTextNoScroll(ower, Location.GetStr(Location.ImagePlaySubtitle), 40, false);Utils.CreateTwinButton(ower, Location.GetStr(Location.PrevImage), () =>{prevImgAction.actionCallback();}, Location.GetStr(Location.NextImage), () =>{nextImgAction.actionCallback();}, false, true);nextImgAction = Utils.SetupAction(ower, "NextImageAction", () =>{SetNextImgPlayIndex();SwitchImage();});prevImgAction = Utils.SetupAction(ower, "PrevImageAction", () =>{SetPrevImgPlayIndex();SwitchImage();});folderPath = Utils.CreateFileChooser(ower, Location.GetStr(Location.SetFolder), DefaultImagePath, false, null, true);folderPath.setCallbackFunction = (url) =>{if (string.IsNullOrEmpty(url)) return;string folder = Utils.GetFolderFromUrl(url);string filename = FileManagerSecure.GetFileName(url);if (!GlobalSetting.isOnImageType) return;if (!ower.IsInitied) return;imgIndex = 0;currentFolderUrl = folder;List<string> files = new List<string>();Utils.GetAllSubFiles(folder, ref files);if (files.Count > 0){imageList.Clear();files.ForEach(p =>{if (p.EndsWith(".jpg") || p.EndsWith(".png") || p.EndsWith(".jpeg") || p.EndsWith(".tiff")){p = p.Replace('\\', '/');imageList.Add(p);}});if (imageList.Count == 0) return;string pathSelect = imageList.FirstOrDefault(x => x.EndsWith(filename));imgIndex = imageList.IndexOf(pathSelect);if (imgIndex < 0) return;string imgURl = imageList[imgIndex];Debug.Log("url: " + imgURl);Utils.LoadTexture(imgURl, slideTextureSetting, (tex) =>{string tmp = FileManagerSecure.GetFileName(imgURl);ower.SyncSourceFormat(tmp);ower.MainTexture = currentTex = tex;ower.SphereBallRenderer.material.mainTexture = Utils.GetVRThumbNailTexture(tex, ower.CurrentRenderMode, 1280);});}};}public override Texture2D GetCurrentFrame(){return currentTex;}int imgIndex = 0;private void SwitchImage(){string imgURl = imageList[imgIndex];Utils.LoadTexture(imgURl, slideTextureSetting, (tex) =>{if (!GlobalSetting.isOnImageType) return;string tmp = FileManagerSecure.GetFileName(imgURl);ower.SyncSourceFormat(tmp);ower.MainTexture = currentTex = tex;ower.SphereBallRenderer.material.mainTexture = Utils.GetVRThumbNailTexture(tex, ower.CurrentRenderMode, 1280);});}private void SetPrevImgPlayIndex(){imgIndex--;if (imgIndex < 0) imgIndex = imageList.Count - 1;}private void SetNextImgPlayIndex(){imgIndex++;if (imgIndex == imageList.Count) imgIndex = 0;}private void SetRandomImgPlayIndex(){if (randomPool.Count == 0){for (int i = 0;i < imageList.Count;i++){randomPool.Add(i);}}int tmpindex = UnityEngine.Random.Range(0, randomPool.Count);imgIndex = randomPool[tmpindex];randomPool.RemoveAt(tmpindex);}public override void DelayInit(){folderPath.setCallbackFunction(folderPath.val);}public void Reset(){folderPath.val = DefaultImagePath;}public override void UnInit(){}}}