/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using UnityEngine.UI;using System.Collections.Generic;using System;using UnityEngine.EventSystems;namespace PluginIdea.MetaVRPlayer{public class PlayControllerModule : VRPlayerModuleBase{private Transform controllerRoot;private Transform imageUIParent, videoUIParent;private Button videoPrevBtn, videoNextBtn, videoPlayBtn, videoPauseBtn, videoStopBtn;private Slider videoTimeSlider;private Text timelabel;private Button imagePrevBtn, imageNextBtn;public PlayControllerModule(MetaVRPlayer ower){this.ower = ower;}public override void Init(){}public override void DelayInit(){controllerRoot = ower.ControllerCanvas.transform.Find("ControllerPanel(Clone)");imageUIParent = controllerRoot.Find("ImagePlay");videoUIParent = controllerRoot.Find("VideoPlay");videoTimeSlider = videoUIParent.Find("Progress").GetComponentInChildren<Slider>();videoPrevBtn = videoUIParent.Find("PrevBtn").GetComponentInChildren<Button>();videoNextBtn = videoUIParent.Find("NextBtn").GetComponentInChildren<Button>();videoPlayBtn = videoUIParent.Find("PlayBtn").GetComponentInChildren<Button>();videoPauseBtn = videoUIParent.Find("PauseBtn").GetComponentInChildren<Button>();videoStopBtn = videoUIParent.Find("StopBtn").GetComponentInChildren<Button>();timelabel = videoUIParent.Find("timeLabel").GetComponentInChildren<Text>();imagePrevBtn = imageUIParent.Find("PrevBtn").GetComponentInChildren<Button>();imageNextBtn = imageUIParent.Find("NextBtn").GetComponentInChildren<Button>();UIInit();}private void UIInit(){imageNextBtn.onClick.AddListener(() =>{ower.imgModule.nextImgAction.actionCallback();});imagePrevBtn.onClick.AddListener(() =>{ower.imgModule.prevImgAction.actionCallback();});videoPrevBtn.onClick.AddListener(() =>{ower.videoModule.PlayPrev();});videoNextBtn.onClick.AddListener(() =>{ower.videoModule.PlayNext();});videoPlayBtn.onClick.AddListener(() =>{ower.videoModule.Play();});videoPauseBtn.onClick.AddListener(() =>{ower.videoModule.Pause();});videoStopBtn.onClick.AddListener(() =>{ower.videoModule.Stop();});videoTimeSlider.onValueChanged.AddListener((val) =>{ower.videoModule.SetProgress(val);});}public override void OnEnter(){ower.ControllerCanvas.gameObject.SetActive(true);}public override void OnOut(){ower.ControllerCanvas.gameObject.SetActive(false);}private bool isShowControlUI;private bool isOnGrab;public override void OnUpdate(){if (GlobalSetting.isUsedAsSkybox || !Utils.IsInVR() || !ower.IsEnter || GlobalSetting.isDraggingFromHead) return;float grabVal = Mathf.Max(SuperController.singleton.GetLeftGrabVal(), SuperController.singleton.GetRightGrabVal());if (grabVal > 0.5f){if (!isOnGrab){OnSelectDown();isOnGrab = true;}}else{isOnGrab = false;}}private void SetPopCanvas(){Transform ctrans = SuperController.singleton.centerCameraTarget.transform;Vector3 pos = ctrans.position + ctrans.forward * 0.4f - ctrans.up * 0.15f;var rt = ower.ControllerCanvas.GetComponent<RectTransform>();rt.position = pos;rt.LookAt(pos + ctrans.forward);}private void OnSelectDown(){isShowControlUI = !isShowControlUI;SetPopCanvas();ower.VRSphereRenderer.material.SetFloat("_IsMono", isShowControlUI ? 1 : 0);if (GlobalSetting.isOnImageType){imageUIParent.gameObject.SetActive(isShowControlUI);}else{videoUIParent.gameObject.SetActive(isShowControlUI);}}public override void UnInit(){}}}