/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;using System.Collections.Generic;using MVR.FileManagementSecure;namespace PluginIdea.MetaVRPlayer{public class LastPara{public bool isActivePlaybackSpeed;}public class VideoPlayerModule : VRPlayerModuleBase{private const string DefaultVideoFolder = "Custom/Assets/Videos";public Action<Texture> onVideoTextureSettedCallback;private JSONStorableFloat thumbNailTime;private JSONStorableBool isLoop;private JSONStorableFloat audioVolume;private JSONStorableFloat playSpeed;private JSONStorableBool isActivePlaySpeed;private JSONStorableFloat playProgress;private JSONStorableUrl videoUrl;private JSONStorableBool isPlayOnStart;private JSONStorableAction beginRenderAction;private JSONStorableAction endRenderAction;private JSONStorableFloat targetRenderFPS;private JSONStorableAction playAction;private JSONStorableAction pauseAction;private JSONStorableAction stopAction;private JSONStorableAction nextVideoAction;private JSONStorableAction prevVideoAction;private UIDynamicButton nextBtn;private UIDynamicButton prevBtn;private VideoPlayer videoPlayer;private AudioSource audioSource;private List<string> videoUrls = new List<string>();private int currentVideoIndex;private LastPara lastPara = new LastPara();private bool isSceneloadSeeked;private Transform audioSourceTrans;public VideoPlayerModule(MetaVRPlayer ower){this.ower = ower;audioSourceTrans = new GameObject("AudioSourceObject").transform;Transform rescaleObject = ower.containingAtom.reParentObject.Find("object/rescaleObject");audioSourceTrans.SetParent(rescaleObject);audioSourceTrans.localPosition = Vector3.zero;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;}private void OnSceneLoaded(){SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(1f, () =>{isSceneloadSeeked = false;thumbNailTime.setCallbackFunction(thumbNailTime.val);}));}public override void Init(){Utils.CreateSpacer(ower, 20, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.VideoPlaySubtitle), 40, true);videoUrl = Utils.SetupVideoChooser(ower, Location.GetStr(Location.ChooseVideoFile), DefaultVideoFolder, true, LoadVideoClip, !ower.isFree);playAction = Utils.SetupAction(this.ower, "Play", Play);stopAction = Utils.SetupAction(this.ower, "Stop", Stop);pauseAction = Utils.SetupAction(this.ower, "Pause", Pause);nextVideoAction = Utils.SetupAction(this.ower, "Next Video", PlayNext);prevVideoAction = Utils.SetupAction(this.ower, "Prev Video", PlayPrev);isLoop = Utils.CreateToggle(ower, Location.GetStr(Location.IsLoop), true, true, !ower.isFree);isLoop.setCallbackFunction = (val =>{videoPlayer.isLooping = val;});audioVolume = Utils.CreateSliderFloat(ower, Location.GetStr(Location.AudioVolume), 1f, 0f, 1f, true, !ower.isFree);audioVolume.setCallbackFunction = (val) =>{audioSource.volume = val;};isActivePlaySpeed = Utils.CreateToggle(ower, Location.GetStr(Location.IsActivePlaybackSpeed), false, true, !ower.isFree);isActivePlaySpeed.setCallbackFunction = (val) =>{videoPlayer.playbackSpeed = val?playSpeed.val : 1;};playSpeed = Utils.CreateSliderFloat(ower, Location.GetStr(Location.PlaySpeed), 1f, 0.1f, 5f, true, !ower.isFree);playSpeed.setCallbackFunction = (val) =>{if (isActivePlaySpeed.val) videoPlayer.playbackSpeed = val;};thumbNailTime = Utils.CreateSliderFloat(ower, Location.GetStr(Location.VideoThumbNailTime), 0f, 0, 200, true, !ower.isFree);thumbNailTime.setCallbackFunction = (val) =>{if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameRate * val);targetFrame = (long)Mathf.Clamp(targetFrame, 0, videoPlayer.frameCount);videoPlayer.frame = targetFrame;if (isSceneloadSeeked){ApplyVideoPlayerTexture(videoPlayer);}else{isSceneloadSeeked = true;}}};Utils.CreateSpacer(ower, 5, true);Utils.CreateButton(ower, Location.GetStr(Location.CaptureCurrentFrame), CaptureAPicture, true, !ower.isFree);Utils.CreateSpacer(ower, 5, true);nextBtn = Utils.CreateButton(ower, Location.GetStr(Location.PlayNext), PlayNext, true, !ower.isFree);prevBtn = Utils.CreateButton(ower, Location.GetStr(Location.PlayPrev), PlayPrev, true, !ower.isFree);Utils.CreateSpacer(ower, 5, true);Utils.CreateButton(ower, Location.GetStr(Location.Play), Play, true, !ower.isFree);Utils.CreateButton(ower, Location.GetStr(Location.Pause), Pause, true, !ower.isFree);Utils.CreateButton(ower, Location.GetStr(Location.Stop), Stop, true, !ower.isFree);AddVideoComponents();}private string filenameSelect;private void SetVideoFiles(string url){filenameSelect = FileManagerSecure.GetFileName(url);string dir = FileManagerSecure.GetDirectoryName(url);List<string> files = new List<string>();Utils.GetAllSubFiles(dir, ref files);if (files.Count > 0){videoUrls = files.Where(u => u.EndsWith(".mp4")).ToList();}}public override void DelayInit(){if (!string.IsNullOrEmpty(videoUrl.val)){videoUrl.Reload();}}public void Reset(){if (videoPlayer != null){videoPlayer.Stop();}videoUrl.val = string.Empty;}public void AddVideoComponents(){videoPlayer = Utils.GetSafeComponent<VideoPlayer>(audioSourceTrans.gameObject);audioSource = Utils.GetSafeComponent<AudioSource>(audioSourceTrans.gameObject);videoPlayer.playOnAwake = false;audioSource.playOnAwake = false;videoPlayer.source = VideoSource.Url;videoPlayer.renderMode = VideoRenderMode.APIOnly;videoPlayer.audioOutputMode = VideoAudioOutputMode.AudioSource;videoPlayer.controlledAudioTrackCount = 1;videoPlayer.EnableAudioTrack(0, true);videoPlayer.SetTargetAudioSource(0, audioSource);videoPlayer.isLooping = isLoop.val;videoPlayer.prepareCompleted += OnVideoPlayerPrepared;videoPlayer.seekCompleted += OnSeedFinished;audioSource.volume = audioVolume.val;}private string pathSelect;private void LoadVideoClip(string path){bool isInPackage = (FileManagerSecure.IsFileInPackage(path));Utils.ActiveBtn(nextBtn, !isInPackage);Utils.ActiveBtn(prevBtn, !isInPackage);if (string.IsNullOrEmpty(path)) return;SetVideoFiles(path);if (videoUrls.Count > 0){if (GlobalSetting.isOnImageType) return;if (!ower.IsInitied) return;currentVideoIndex = 0;pathSelect = videoUrls.FirstOrDefault(x => x.EndsWith(filenameSelect));currentVideoIndex = videoUrls.IndexOf(pathSelect);if (currentVideoIndex < 0) currentVideoIndex = 0;VideoDataPrepare();}}public void PlayNext(){if (videoUrls.Count > 0){currentVideoIndex++;if (currentVideoIndex > videoUrls.Count - 1)                    currentVideoIndex = 0;VideoDataPrepare();}}public void PlayPrev(){if (videoUrls.Count > 0){currentVideoIndex--;if (currentVideoIndex < 0)                    currentVideoIndex = videoUrls.Count - 1;VideoDataPrepare();}}public override Texture2D GetCurrentFrame(){if (videoPlayer.texture != null){return Utils.TextureToTexture2D(videoPlayer.texture);}return null;}private const string SHOT_DIRECTORY = "Saves/CameraShot/";private void CaptureAPicture(){if (videoPlayer.texture != null){string dgreeStr = ower.settingModule.isVR180.val ? "180" : "360";string formatStr = "M";string format = ower.settingModule.sourceFormat.val;switch (format){case "Mono": formatStr = "M";break;case "UpBottom": formatStr = "UD";break;case "LeftRight": formatStr = "LR";break;default:                        break;}string filename = string.Format("{0}&{1}&{2}.jpg", GetFilename(),formatStr, dgreeStr);Texture2D t2d = Utils.TextureToTexture2D(videoPlayer.texture);byte[] bytes = t2d.EncodeToJPG(100);FileManagerSecure.CreateDirectory(SHOT_DIRECTORY);FileManagerSecure.WriteAllBytes(SHOT_DIRECTORY + filename, bytes);}}private string GetFilename(){return ((int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds).ToString();}private void VideoDataPrepare(){videoPlayer.Stop();string firstUrl = videoUrls[currentVideoIndex];if (!firstUrl.StartsWith("http:")){string tmp = FileManagerSecure.GetFileName(firstUrl);Debug.Log("sync: " + tmp);ower.SyncSourceFormat(tmp);string realpath = Utils.GetGameRootDir() + "/" + firstUrl;videoPlayer.url = realpath;videoPlayer.Play();videoPlayer.Pause();}}private bool isCommonSeeked;private void OnVideoPlayerPrepared(VideoPlayer source){Debug.Log(source.url + " is prepared");source.texture.wrapMode = TextureWrapMode.Repeat;source.texture.filterMode = FilterMode.Trilinear;thumbNailTime.max = videoPlayer.frameCount / videoPlayer.frameRate;if (onVideoTextureSettedCallback != null) onVideoTextureSettedCallback(source.texture);SetTime(thumbNailTime.max * 0.1f);isCommonSeeked = true;}private void OnSeedFinished(VideoPlayer player){if (isSceneloadSeeked || isCommonSeeked){if (isCommonSeeked) isCommonSeeked = false;SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(.2f, () =>{ApplyVideoPlayerTexture(videoPlayer);}));}}private Texture2D lastThumbnailTex;private void ApplyVideoPlayerTexture(VideoPlayer source){ower.MainTexture = source.texture;if (lastThumbnailTex != null) GameObject.Destroy(lastThumbnailTex);Texture2D tex = Utils.TextureToTexture2D(source.texture);ower.SphereBallRenderer.material.mainTexture = Utils.GetVRThumbNailTexture(tex, ower.CurrentRenderMode, 1280);lastThumbnailTex = tex;}public void SetProgress(float progress){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameCount * progress);videoPlayer.frame = targetFrame;}}private void SetTime(float time){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameRate * time);targetFrame = (long)Mathf.Clamp(targetFrame, 0, videoPlayer.frameCount);videoPlayer.frame = targetFrame;videoPlayer.Pause();}}public void Play(){if (videoPlayer != null) videoPlayer.Play();}public void Stop(){if (videoPlayer != null) videoPlayer.Stop();}public void Pause(){if (videoPlayer != null) videoPlayer.Pause();}public override void OnEnter(){Play();}public override void OnOut(){Pause();}public override void UnInit(){videoUrl.val = string.Empty;SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;GameObject.Destroy(videoPlayer);GameObject.Destroy(audioSource);GameObject.Destroy(audioSourceTrans.gameObject);Resources.UnloadUnusedAssets();}}}